<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <link rel="icon" type="image/svg+xml" href="../favicon.svg">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Mortar & Pestle | The Next Generation of Question Grinding</title>
  <link rel="stylesheet" href="../assets/style.css">
  <meta name="robots" content="index,follow">
  <meta name="copyright" content="Public Domain">
  <meta name="keywords" content="pestle, mortar, mortar & pestle, ib questionbank, pirateib">
  <meta name="description" content="Practice IB Exam-Style Questions, create topic-wise tests, and much more!">
  <meta property="og:locale" content="en_US">
  <meta property="og:type" content="website">
  <meta property="og:title" content="Mortar & Pestle | The Next Generation of Question Grinding">
  <meta property="og:description" content="Practice IB Exam-Style Questions, create topic-wise tests, and much more!">
  <meta property="og:url" content="https://pestle.pages.dev/">
  <meta property="og:site_name" content="Mortar & Pestle | The Next Generation of Question Grinding">
  <meta name="twitter:title" content="Mortar & Pestle | The Next Generation of Question Grinding">
  <meta name="twitter:description" content="Practice IB Exam-Style Questions, create topic-wise tests, and much more!">
  <link rel="preload" href="./index.js" as="script">
</head>

<body>
  <div id="loadingBanner" style="display: none; position: fixed; bottom: 0; left: 0; right: 0; background: rgba(0, 0, 0, 0.7); color: white; text-align: center; padding: 20px; z-index: 9999;">
    Loading, please wait...
    </div>
  <div id="root">
    <header>
      <div style="position: fixed; right: 15px; z-index: 9999;">
        <button id="addalltoPDFbtn" class="btn-primary hidden" onclick="addalltoPDF()">Add all Qs to PDF</button>
        <button id="generatePDFbtn" class="btn-primary hidden" onclick="generatePDF()">Generate PDF!</button>
        <button id="darkmodebtn" class="btn-primary" onclick="toggleDarkMode()">Dark Mode</button>
        <button id="helpbtn" class="btn-secondary" onclick="toggleHelp()">Help</button>
      </div>
    </header>
    <div id="appContainer" class="h-full w-full">
      <div id="left-col" class="flex flex-col bg-white p-2">
        <div class="p-3"><a href="../index.html"><button class="btn-primary">< Go Home</button></button></a></div>
        <div>
          <h1>Mortar & Pestle</h1>
        </div>
        <div class="mt-2 flex cursor-pointer items-center" onclick="toggleModal()">
          <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none"
            stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" style="color: red">
            <circle cx="12" cy="12" r="10"></circle>
            <line x1="12" y1="8" x2="12" y2="16"></line>
            <line x1="8" y1="12" x2="16" y2="12"></line>
          </svg>
          <h3 class="ms-2" style="color: red">Choose a QuestionBank</h3>
        </div>
        <br>
        <hr>
        <br>
        <div id="topic-list"></div>
      </div>
      <div id="right-col" class="flex flex-col bg-gray-100 p-2">
      </div>
      <div id="modal" class="fixed left-0 top-0 hidden flex h-full w-full items-center justify-center bg-black/70">
        <div class="flex h-full w-full md:h-3/4 md:w-3/4 flex-col border bg-gray-100 p-4">
          <div class="flex justify-between">
            <h1>Select QuestionBank</h1>
            <svg xmlns="http://www.w3.org/2000/svg" width="2rem" height="2rem" viewBox="0 0 24 24" fill="none"
              stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"
              class="cursor-pointer text-primary" onclick="toggleModal()">
              <rect x="3" y="3" width="18" height="18" rx="2" ry="2"></rect>
              <line x1="9" y1="9" x2="15" y2="15"></line>
              <line x1="15" y1="9" x2="9" y2="15"></line>
            </svg>
          </div>
          <div class="m-0 mt-2 overflow-auto p-0 font-serif max-h-60vh">
            <div class="font-sans">
              <div class="flex flex-col">
                <div class="flex items-center mt-2">
                  <button id="bioqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Biology QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="bmqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Business Management QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="chemqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Chemistry QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="compsciqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Computer Science QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="destechqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Design Technology QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="digsocqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Digital Society QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="econqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Economics QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="essqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB ESS QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="geoqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Geography QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="histqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB History QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="mathaaqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Math AA QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="mathaiqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Math AI QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="phyqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Physics QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="psychqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB Psychology QuestionBank
                  </h4>
                </div>
                <div class="flex items-center mt-2">
                  <button id="sehsqb" class="btn-primary flex items-center" onclick="toggleModal()">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24"
                      fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round"
                      stroke-linejoin="round" class="me-2">
                      <circle cx="12" cy="12" r="10"></circle>
                      <line x1="12" y1="8" x2="12" y2="16"></line>
                      <line x1="8" y1="12" x2="16" y2="12"></line>
                    </svg> Add
                  </button>
                  <h4 class="ms-2">IB SEHS QuestionBank
                  </h4>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div id="helpmenu" style="z-index: 99999;" class="fixed left-0 top-0 hidden flex h-full w-full items-center justify-center bg-black/70">
        <div class="flex h-full w-full md:h-3/4 md:w-3/4 flex-col border bg-gray-100 p-4">
          <div class="flex justify-between">
            <h1>Help Menu & FAQ</h1>
            <svg xmlns="http://www.w3.org/2000/svg" width="2rem" height="2rem" viewBox="0 0 24 24" fill="none"
              stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"
              class="cursor-pointer text-primary" onclick="toggleHelp()">
              <rect x="3" y="3" width="18" height="18" rx="2" ry="2"></rect>
              <line x1="9" y1="9" x2="15" y2="15"></line>
              <line x1="15" y1="9" x2="9" y2="15"></line>
            </svg>
          </div>
          <div class="m-0 mt-2 overflow-auto p-0 font-serif max-h-60vh">
            <div class="font-sans">
              <h3>· Where are QBv6 questions? This shit is old!</h3>
              <br>
              <p>We are going to add them soon. We are also students with busy lives. <b>Be patient!</b></p>
              <br>
              <h3>· I tried to save all the questions as PDF, and my computer got frozen!</h3>
              <br>
              <p>This is normal behavior and expected. It might take a minute or two to fully load the questions and render the PDF. It is also a very resource-intensive process, so just be patient. <b>To solve this issue, we provide full PDF QuestionBanks with markschemes for all subjects <a style="color:blue;" href="https://buzzheavier.com/5lzuu3dflxbs/" target="_blank">here</a>.</b></p>
              <br>
              <h3>· Some questions from the wrong topic are being added to the PDF!</h3>
              <br>
              <p>This happens when you uncheck a topic after having selected some questions for exporting to PDF on it. To solve that issue, <b>simply reload the page</b>.</p>
              <br>
              <h3>· I tried to load a questionbank, but nothing happened.</h3>
              <br>
              <p><b>Most likely it's a bug.</b> Try again until you see the "Loading, please wait..." banner on the bottom.<br>If you don't get any such banner after many tries, perhaps Cloudflare is blocked in your country? <b>Try using a VPN or download our offline version (zipped) <a style="color:blue" href="https://gitlab.com/ibdocs.2/pestlev3/-/archive/main/pestlev3-main.zip" target="_blank">here</a>.</b></p>
              <br>
              <h3>· I'm a developer and I want to contribute!</h3>
              <br>
              <p><b>The code for Mortar & Pestle is fully open source <a style="color:blue;" href="https://gitlab.com/ibdocs.2/pestlev3/" target="_blank">here</a></b>, feel free to submit pull requests or issues. Emails to <a style="color:blue" href="mailto:pirateib.qfz17@aleeas.com" target="_blank">pirateib.qfz17@aleeas.com</a> are also welcome with ideas/improvements, but please be specific and avoid trolling (DMCA, etc).</p>
              <br>
              <h3>· I'm a user and I want to reward you for your work!</h3>
              <br>
              <p>See <b><a style="color:blue;" href="https://t.me/pirateIBnew/215" target="_blank">this Telegram post</a></b> for info on how to contribute to pirateIB as a whole. TLDR: We want IB resources, not money.</p>
            </div>
          </div>
        </div>
      </div>
      <div id="markscheme" class="fixed left-0 top-0 hidden flex h-full w-full items-center justify-center bg-black/70">
        <div id="markscheme-box" class="flex h-full w-full md:h-3/4 md:w-3/4 flex-col border bg-gray-100 p-4">
          <div id="markscheme-box2" class="flex justify-between">
            <h3>Markscheme</h3>
          </div>
        </div>
      </div>
      <div id="report" class="fixed left-0 top-0 hidden flex h-full w-full items-center justify-center bg-black/70">
        <div id="report-box" class="flex h-full w-full md:h-3/4 md:w-3/4 flex-col border bg-gray-100 p-4">
          <div id="report-box2" class="flex justify-between">
            <h3>Examiners report</h3>
          </div>
        </div>
      </div>

    </div>
  </div>
  <script src="./index.js"></script>
</body>

</html>
